(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

var has = Object.prototype.hasOwnProperty
  , prefix = '~';

/**
 * Constructor to create a storage for our `EE` objects.
 * An `Events` instance is a plain object whose properties are event names.
 *
 * @constructor
 * @api private
 */
function Events() {}

//
// We try to not inherit from `Object.prototype`. In some engines creating an
// instance in this way is faster than calling `Object.create(null)` directly.
// If `Object.create(null)` is not supported we prefix the event names with a
// character to make sure that the built-in object properties are not
// overridden or used as an attack vector.
//
if (Object.create) {
  Events.prototype = Object.create(null);

  //
  // This hack is needed because the `__proto__` property is still inherited in
  // some old browsers like Android 4, iPhone 5.1, Opera 11 and Safari 5.
  //
  if (!new Events().__proto__) prefix = false;
}

/**
 * Representation of a single event listener.
 *
 * @param {Function} fn The listener function.
 * @param {Mixed} context The context to invoke the listener with.
 * @param {Boolean} [once=false] Specify if the listener is a one-time listener.
 * @constructor
 * @api private
 */
function EE(fn, context, once) {
  this.fn = fn;
  this.context = context;
  this.once = once || false;
}

/**
 * Minimal `EventEmitter` interface that is molded against the Node.js
 * `EventEmitter` interface.
 *
 * @constructor
 * @api public
 */
function EventEmitter() {
  this._events = new Events();
  this._eventsCount = 0;
}

/**
 * Return an array listing the events for which the emitter has registered
 * listeners.
 *
 * @returns {Array}
 * @api public
 */
EventEmitter.prototype.eventNames = function eventNames() {
  var names = []
    , events
    , name;

  if (this._eventsCount === 0) return names;

  for (name in (events = this._events)) {
    if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
  }

  if (Object.getOwnPropertySymbols) {
    return names.concat(Object.getOwnPropertySymbols(events));
  }

  return names;
};

/**
 * Return the listeners registered for a given event.
 *
 * @param {String|Symbol} event The event name.
 * @param {Boolean} exists Only check if there are listeners.
 * @returns {Array|Boolean}
 * @api public
 */
EventEmitter.prototype.listeners = function listeners(event, exists) {
  var evt = prefix ? prefix + event : event
    , available = this._events[evt];

  if (exists) return !!available;
  if (!available) return [];
  if (available.fn) return [available.fn];

  for (var i = 0, l = available.length, ee = new Array(l); i < l; i++) {
    ee[i] = available[i].fn;
  }

  return ee;
};

/**
 * Calls each of the listeners registered for a given event.
 *
 * @param {String|Symbol} event The event name.
 * @returns {Boolean} `true` if the event had listeners, else `false`.
 * @api public
 */
EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
  var evt = prefix ? prefix + event : event;

  if (!this._events[evt]) return false;

  var listeners = this._events[evt]
    , len = arguments.length
    , args
    , i;

  if (listeners.fn) {
    if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);

    switch (len) {
      case 1: return listeners.fn.call(listeners.context), true;
      case 2: return listeners.fn.call(listeners.context, a1), true;
      case 3: return listeners.fn.call(listeners.context, a1, a2), true;
      case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
      case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
      case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
    }

    for (i = 1, args = new Array(len -1); i < len; i++) {
      args[i - 1] = arguments[i];
    }

    listeners.fn.apply(listeners.context, args);
  } else {
    var length = listeners.length
      , j;

    for (i = 0; i < length; i++) {
      if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);

      switch (len) {
        case 1: listeners[i].fn.call(listeners[i].context); break;
        case 2: listeners[i].fn.call(listeners[i].context, a1); break;
        case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
        case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
        default:
          if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
            args[j - 1] = arguments[j];
          }

          listeners[i].fn.apply(listeners[i].context, args);
      }
    }
  }

  return true;
};

/**
 * Add a listener for a given event.
 *
 * @param {String|Symbol} event The event name.
 * @param {Function} fn The listener function.
 * @param {Mixed} [context=this] The context to invoke the listener with.
 * @returns {EventEmitter} `this`.
 * @api public
 */
EventEmitter.prototype.on = function on(event, fn, context) {
  var listener = new EE(fn, context || this)
    , evt = prefix ? prefix + event : event;

  if (!this._events[evt]) this._events[evt] = listener, this._eventsCount++;
  else if (!this._events[evt].fn) this._events[evt].push(listener);
  else this._events[evt] = [this._events[evt], listener];

  return this;
};

/**
 * Add a one-time listener for a given event.
 *
 * @param {String|Symbol} event The event name.
 * @param {Function} fn The listener function.
 * @param {Mixed} [context=this] The context to invoke the listener with.
 * @returns {EventEmitter} `this`.
 * @api public
 */
EventEmitter.prototype.once = function once(event, fn, context) {
  var listener = new EE(fn, context || this, true)
    , evt = prefix ? prefix + event : event;

  if (!this._events[evt]) this._events[evt] = listener, this._eventsCount++;
  else if (!this._events[evt].fn) this._events[evt].push(listener);
  else this._events[evt] = [this._events[evt], listener];

  return this;
};

/**
 * Remove the listeners of a given event.
 *
 * @param {String|Symbol} event The event name.
 * @param {Function} fn Only remove the listeners that match this function.
 * @param {Mixed} context Only remove the listeners that have this context.
 * @param {Boolean} once Only remove one-time listeners.
 * @returns {EventEmitter} `this`.
 * @api public
 */
EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
  var evt = prefix ? prefix + event : event;

  if (!this._events[evt]) return this;
  if (!fn) {
    if (--this._eventsCount === 0) this._events = new Events();
    else delete this._events[evt];
    return this;
  }

  var listeners = this._events[evt];

  if (listeners.fn) {
    if (
         listeners.fn === fn
      && (!once || listeners.once)
      && (!context || listeners.context === context)
    ) {
      if (--this._eventsCount === 0) this._events = new Events();
      else delete this._events[evt];
    }
  } else {
    for (var i = 0, events = [], length = listeners.length; i < length; i++) {
      if (
           listeners[i].fn !== fn
        || (once && !listeners[i].once)
        || (context && listeners[i].context !== context)
      ) {
        events.push(listeners[i]);
      }
    }

    //
    // Reset the array, or remove it completely if we have no more listeners.
    //
    if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
    else if (--this._eventsCount === 0) this._events = new Events();
    else delete this._events[evt];
  }

  return this;
};

/**
 * Remove all listeners, or those of the specified event.
 *
 * @param {String|Symbol} [event] The event name.
 * @returns {EventEmitter} `this`.
 * @api public
 */
EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
  var evt;

  if (event) {
    evt = prefix ? prefix + event : event;
    if (this._events[evt]) {
      if (--this._eventsCount === 0) this._events = new Events();
      else delete this._events[evt];
    }
  } else {
    this._events = new Events();
    this._eventsCount = 0;
  }

  return this;
};

//
// Alias methods names because people roll like that.
//
EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
EventEmitter.prototype.addListener = EventEmitter.prototype.on;

//
// This function doesn't apply anymore.
//
EventEmitter.prototype.setMaxListeners = function setMaxListeners() {
  return this;
};

//
// Expose the prefix.
//
EventEmitter.prefixed = prefix;

//
// Allow `EventEmitter` to be imported as module namespace.
//
EventEmitter.EventEmitter = EventEmitter;

//
// Expose the module.
//
if ('undefined' !== typeof module) {
  module.exports = EventEmitter;
}

},{}],2:[function(require,module,exports){
var ColorProperty, DialInput, ImageInput, NumberInput, NumberProperty, PairedInputRow, Panel, PanelRow, SliderInput, StereoInputRow, StringProperty, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

StringProperty = FramerComponents.StringProperty, NumberProperty = FramerComponents.NumberProperty, ColorProperty = FramerComponents.ColorProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow;

TextInput = FramerComponents.TextInput, ImageInput = FramerComponents.ImageInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput;

exports.BorderPanel = (function(superClass) {
  extend(BorderPanel, superClass);

  function BorderPanel(options) {
    var borderColorProperty, borderWidthProperty, shadowColorProperty, shadowSpreadProperty;
    if (options == null) {
      options = {};
    }
    this.caption = "Border Panel";
    BorderPanel.__super__.constructor.call(this, _.defaults(options, {}));
    borderColorProperty = new ColorProperty({
      dataPath: "borderColor"
    });
    borderWidthProperty = new NumberProperty({
      min: 0,
      dataPath: "borderWidth",
      caption: "Width",
      abbreviatedCaption: "W"
    });
    borderColorProperty.on("change:value", (function(_this) {
      return function(newValue) {
        if (newValue == null) {
          return;
        }
        if (borderWidthProperty.value === null || borderWidthProperty.value === 0) {
          return borderWidthProperty.value = 1;
        }
      };
    })(this));
    this.borderRow = new StereoInputRow({
      caption: "Border",
      properties: [borderColorProperty, borderWidthProperty]
    });
    this.radiusRow = new PairedInputRow({
      caption: "Radius",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "borderRadius",
        min: 0,
        sliderMin: 0,
        sliderMax: 100,
        step: 1,
        decimals: 0
      })
    });
    shadowColorProperty = new ColorProperty({
      dataPath: "shadowColor"
    });
    shadowSpreadProperty = new NumberProperty({
      dataPath: "shadowSpread",
      caption: "Spread",
      abbreviatedCaption: "S"
    });
    shadowColorProperty.on("change:value", (function(_this) {
      return function(newValue) {
        if (newValue == null) {
          return;
        }
        if (shadowSpreadProperty.value === null || shadowSpreadProperty.value === 0) {
          return shadowSpreadProperty.value = 1;
        }
      };
    })(this));
    this.shadowColorRow = new StereoInputRow({
      caption: "Shadow",
      properties: [shadowColorProperty, shadowSpreadProperty]
    });
    this.shadowPositionRow = new StereoInputRow({
      caption: " ",
      properties: [
        new NumberProperty({
          dataPath: "shadowX",
          caption: "X"
        }), new NumberProperty({
          dataPath: "shadowY",
          caption: "Y"
        })
      ]
    });
    this.shadowBlurRow = new PairedInputRow({
      caption: " ",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "shadowBlur",
        min: 0,
        sliderMax: 100,
        step: 1,
        decimals: 0,
        caption: "Blur",
        abbreviatedCaption: "B"
      })
    });
    this.add(this.borderRow);
    this.add(this.radiusRow);
    this.add(this.shadowColorRow);
    this.add(this.shadowPositionRow);
    this.add(this.shadowBlurRow);
  }

  return BorderPanel;

})(Panel);


},{}],3:[function(require,module,exports){
var ColorProperty, ComboTextInput, DialInput, NumberInput, NumberProperty, PairedInputRow, Panel, PanelRow, Property, SliderInput, StereoInputRow, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Property = FramerComponents.Property, NumberProperty = FramerComponents.NumberProperty, ColorProperty = FramerComponents.ColorProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow;

TextInput = FramerComponents.TextInput, ComboTextInput = FramerComponents.ComboTextInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput;

exports.FiltersPanel = (function(superClass) {
  extend(FiltersPanel, superClass);

  function FiltersPanel(options) {
    var blurRow, brightnessRow, contrastRow, grayscaleRow, huerotateRow, invertRow, saturateRow, sepiaRow;
    if (options == null) {
      options = {};
    }
    this.caption = "Filters";
    FiltersPanel.__super__.constructor.call(this, _.defaults(options, {}));
    blurRow = new PairedInputRow({
      caption: "Blur",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "blur",
        min: 0,
        sliderMax: 50,
        step: 1,
        decimals: 0
      })
    });
    brightnessRow = new PairedInputRow({
      caption: "Brightness",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "brightness",
        min: 0,
        sliderMin: 0,
        sliderMax: 300,
        step: 1,
        decimals: 0
      })
    });
    contrastRow = new PairedInputRow({
      caption: "Contrast",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "contrast",
        min: 0,
        max: 100,
        step: 1,
        decimals: 0
      })
    });
    grayscaleRow = new PairedInputRow({
      caption: "Grayscale",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "grayscale",
        min: 0,
        max: 100,
        step: 1,
        decimals: 0
      })
    });
    huerotateRow = new PairedInputRow({
      caption: "hueRotate",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "hueRotate",
        min: 0,
        max: 360,
        step: 1,
        decimals: 0
      })
    });
    invertRow = new PairedInputRow({
      caption: "Invert",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "invert",
        min: 0,
        max: 100,
        step: 1,
        decimals: 0
      })
    });
    saturateRow = new PairedInputRow({
      caption: "Saturate",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "saturate",
        min: 0,
        max: 100,
        step: 1,
        decimals: 0
      })
    });
    sepiaRow = new PairedInputRow({
      caption: "Sepia",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "sepia",
        min: 0,
        max: 100,
        step: 1,
        decimals: 0
      })
    });
    this.add(blurRow);
    this.add(brightnessRow);
    this.add(contrastRow);
    this.add(grayscaleRow);
    this.add(huerotateRow);
    this.add(invertRow);
    this.add(saturateRow);
    this.add(sepiaRow);
  }

  return FiltersPanel;

})(Panel);


},{}],4:[function(require,module,exports){
var ColorProperty, ComboTextInput, DialInput, ImageInput, MonoInputRow, NumberInput, NumberProperty, OptionListProperty, PairedInputRow, Panel, PanelRow, Property, SegmentedInput, SelectInput, SliderInput, StereoInputRow, StringProperty, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Property = FramerComponents.Property, NumberProperty = FramerComponents.NumberProperty, ColorProperty = FramerComponents.ColorProperty, StringProperty = FramerComponents.StringProperty, OptionListProperty = FramerComponents.OptionListProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, MonoInputRow = FramerComponents.MonoInputRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow, SelectInput = FramerComponents.SelectInput;

TextInput = FramerComponents.TextInput, ComboTextInput = FramerComponents.ComboTextInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput, SegmentedInput = FramerComponents.SegmentedInput, ImageInput = FramerComponents.ImageInput;

exports.FontPanel = (function(superClass) {
  extend(FontPanel, superClass);

  function FontPanel(options) {
    var alignRow, colorRow, fontRow, letterSpacingRow, lineHeightRow, sizeRow, weightRow;
    if (options == null) {
      options = {};
    }
    this.caption = "Font";
    FontPanel.__super__.constructor.call(this, _.defaults(options, {}));
    fontRow = new MonoInputRow({
      caption: "Font",
      property: new OptionListProperty({
        editorType: SelectInput,
        dataPath: "fontFamily",
        availableOptions: {
          "Helvetica": "Helvetica",
          "SF Text": "San Francisco",
          "Courier": "Courier"
        }
      })
    });
    sizeRow = new PairedInputRow({
      caption: "Size",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        caption: "px",
        dataPath: "fontSize",
        min: 0,
        sliderMin: 0,
        sliderMax: 100,
        step: 1,
        decimals: 0
      })
    });
    weightRow = new PairedInputRow({
      caption: "Weight",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        caption: "",
        dataPath: "fontWeight",
        min: 0,
        sliderMin: 0,
        sliderMax: 1000,
        step: 100,
        decimals: 0
      })
    });
    colorRow = new StereoInputRow({
      caption: "Color",
      properties: [
        new ColorProperty({
          dataPath: "color"
        }), new StringProperty({
          caption: "Choose",
          dataPath: "color",
          editorType: ImageInput
        })
      ]
    });
    alignRow = new MonoInputRow({
      caption: "Align",
      property: new OptionListProperty({
        editorType: SegmentedInput,
        dataPath: "textAlign",
        availableOptions: {
          "left": "Left",
          "center": "Center",
          "right": "Right"
        }
      })
    });
    lineHeightRow = new PairedInputRow({
      caption: "Line",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        caption: "x",
        dataPath: "lineHeight",
        min: 0,
        sliderMin: 0,
        sliderMax: 3,
        step: 0.1,
        decimals: 1
      })
    });
    letterSpacingRow = new PairedInputRow({
      caption: "Spacing",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        caption: "px",
        dataPath: "letterSpacing",
        min: 0,
        sliderMin: 0,
        sliderMax: 3,
        step: 0.1,
        decimals: 1
      })
    });
    this.add(fontRow);
    this.add(sizeRow);
    this.add(weightRow);
    this.add(colorRow);
    this.add(alignRow);
    this.add(lineHeightRow);
    this.add(letterSpacingRow);
  }

  return FontPanel;

})(Panel);


},{}],5:[function(require,module,exports){
var ColorProperty, DialInput, ImageInput, NumberInput, NumberProperty, PairedInputRow, Panel, PanelRow, SliderInput, StereoInputRow, StringProperty, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

StringProperty = FramerComponents.StringProperty, NumberProperty = FramerComponents.NumberProperty, ColorProperty = FramerComponents.ColorProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow;

TextInput = FramerComponents.TextInput, ImageInput = FramerComponents.ImageInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput;

exports.MainPanelBase = (function(superClass) {
  extend(MainPanelBase, superClass);

  function MainPanelBase(options) {
    if (options == null) {
      options = {};
    }
    this.caption = "Main Panel";
    MainPanelBase.__super__.constructor.call(this, _.defaults(options, {}));
    this.positionRow = new StereoInputRow({
      caption: "Position",
      properties: [
        new NumberProperty({
          dataPath: "x",
          caption: "X"
        }), new NumberProperty({
          dataPath: "y",
          caption: "Y"
        })
      ]
    });
    this.sizeRow = new StereoInputRow({
      caption: "Size",
      properties: [
        new NumberProperty({
          dataPath: "width",
          caption: "W",
          min: 0
        }), new NumberProperty({
          dataPath: "height",
          caption: "H",
          min: 0
        })
      ]
    });
    this.opacityRow = new PairedInputRow({
      caption: "Opacity",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        caption: "",
        dataPath: "opacity",
        min: 0,
        max: 1,
        decimals: 2,
        step: 0.05
      })
    });
  }

  return MainPanelBase;

})(Panel);

exports.MainPanel = (function(superClass) {
  extend(MainPanel, superClass);

  function MainPanel(options) {
    if (options == null) {
      options = {};
    }
    MainPanel.__super__.constructor.apply(this, arguments);
    this.backgroundRow = new StereoInputRow({
      caption: "Background",
      properties: [
        new ColorProperty({
          dataPath: "backgroundColor"
        }), new StringProperty({
          caption: "Choose",
          dataPath: "image",
          editorType: ImageInput
        })
      ]
    });
    this.add(this.positionRow);
    this.add(this.sizeRow);
    this.add(this.backgroundRow);
    this.add(this.opacityRow);
  }

  return MainPanel;

})(exports.MainPanelBase);

exports.TextMainPanel = (function(superClass) {
  extend(TextMainPanel, superClass);

  function TextMainPanel(options) {
    if (options == null) {
      options = {};
    }
    TextMainPanel.__super__.constructor.apply(this, arguments);
    this.add(this.positionRow);
    this.add(this.sizeRow);
    this.add(this.colorRow);
    this.add(this.opacityRow);
  }

  return TextMainPanel;

})(exports.MainPanelBase);


},{}],6:[function(require,module,exports){
var AutoCodePanelStack, BorderPanel, FiltersPanel, FontPanel, MainPanel, TransformPanel,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AutoCodePanelStack = require('../shared/AutoCodePanelStack').AutoCodePanelStack;

MainPanel = require('./MainPanel').MainPanel;

FontPanel = require('./FontPanel').FontPanel;

BorderPanel = require('./BorderPanel').BorderPanel;

TransformPanel = require('./TransformPanel').TransformPanel;

FiltersPanel = require('./FiltersPanel').FiltersPanel;

exports.PropertiesPanelStack = (function(superClass) {
  extend(PropertiesPanelStack, superClass);

  function PropertiesPanelStack(options) {
    if (options == null) {
      options = {};
    }
    this.currentTabName = 'properties';
    PropertiesPanelStack.__super__.constructor.call(this, options);
    this.directManipulationProperties = {
      x: {
        round: true,
        "default": 0
      },
      y: {
        round: true,
        "default": 0
      },
      width: {
        round: true,
        "default": Framer.Defaults.Layer.width
      },
      height: {
        round: true,
        "default": Framer.Defaults.Layer.height
      },
      rotation: {
        round: true,
        "default": 0
      },
      rotationX: {
        round: true,
        "default": 0
      },
      rotationY: {
        round: true,
        "default": 0
      },
      rotationZ: {
        round: true,
        "default": 0
      },
      scale: {
        round: false,
        "default": 1
      },
      scaleX: {
        round: false,
        "default": 1
      },
      scaleY: {
        round: false,
        "default": 1
      },
      originX: {
        round: false,
        "default": 0.5
      },
      originY: {
        round: false,
        "default": 0.5
      },
      originZ: {
        round: false,
        "default": 0
      },
      borderRadius: {
        round: true,
        "default": 0
      }
    };
    this.mainPanel = new MainPanel;
    this.add(this.mainPanel);
    this.borderPanel = new BorderPanel;
    this.add(this.borderPanel);
    this.transformPanel = new TransformPanel;
    this.add(this.transformPanel);
    this.filtersPanel = new FiltersPanel;
    this.filtersPanelToggle = this.addWithToggle(this.filtersPanel);
  }

  PropertiesPanelStack.prototype.configure = function(data) {
    var auxiliraryPanels, collapsiblePanelToggles, i, j, k, l, len, len1, len2, len3, len4, len5, m, n, panel, panelType, ref, row, targetType, toggle, toggleOpen, toggleStates;
    PropertiesPanelStack.__super__.configure.call(this, data);
    targetType = data.objectType;
    panelType = data.panelType;
    toggleStates = data.toggleStates;
    collapsiblePanelToggles = [this.filtersPanelToggle];
    auxiliraryPanels = [this.borderPanel, this.transformPanel];
    this.mainPanel.unhideAllRows();
    for (i = 0, len = auxiliraryPanels.length; i < len; i++) {
      panel = auxiliraryPanels[i];
      panel.hide(false);
    }
    for (j = 0, len1 = collapsiblePanelToggles.length; j < len1; j++) {
      toggle = collapsiblePanelToggles[j];
      toggle.hide(false);
    }
    if (targetType === "@BackgroundLayerOptions") {
      for (k = 0, len2 = auxiliraryPanels.length; k < len2; k++) {
        panel = auxiliraryPanels[k];
        panel.hide(true);
      }
      for (l = 0, len3 = collapsiblePanelToggles.length; l < len3; l++) {
        toggle = collapsiblePanelToggles[l];
        toggle.hide(true);
      }
      ref = this.mainPanel.rows;
      for (m = 0, len4 = ref.length; m < len4; m++) {
        row = ref[m];
        row.visible = false;
      }
      this.mainPanel.backgroundRow.visible = true;
      this.mainPanel.render();
    }
    this.omitDefaults = panelType !== "state";
    for (n = 0, len5 = collapsiblePanelToggles.length; n < len5; n++) {
      toggle = collapsiblePanelToggles[n];
      toggleOpen = toggleStates != null ? toggleStates[toggle.target.caption] : void 0;
      if (toggleOpen && toggle.visible) {
        toggle.open(false);
        toggle.target.unhideAllRows();
      } else {
        toggle.close(false);
      }
    }
    return this.render();
  };

  return PropertiesPanelStack;

})(AutoCodePanelStack);


},{"../shared/AutoCodePanelStack":9,"./BorderPanel":2,"./FiltersPanel":3,"./FontPanel":4,"./MainPanel":5,"./TransformPanel":7}],7:[function(require,module,exports){
var ColorProperty, ComboTextInput, DialInput, NumberInput, NumberProperty, PairedInputRow, Panel, PanelRow, Property, SliderInput, StereoInputRow, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Property = FramerComponents.Property, NumberProperty = FramerComponents.NumberProperty, ColorProperty = FramerComponents.ColorProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow;

TextInput = FramerComponents.TextInput, ComboTextInput = FramerComponents.ComboTextInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput;

exports.TransformPanel = (function(superClass) {
  extend(TransformPanel, superClass);

  function TransformPanel(options) {
    if (options == null) {
      options = {};
    }
    this.caption = "Transform";
    TransformPanel.__super__.constructor.call(this, _.defaults(options, {}));
    this.scaleRow1 = new PairedInputRow({
      caption: "Scale",
      editorTypes: [NumberInput, SliderInput],
      rightEditorInsetY: 2,
      property: new NumberProperty({
        dataPath: "scale",
        min: 0,
        sliderMax: 2,
        step: 0.05,
        decimals: 2,
        caption: " "
      })
    });
    this.scaleRow2 = new StereoInputRow({
      caption: " ",
      properties: [
        new NumberProperty({
          dataPath: "scaleX",
          caption: "X",
          decimals: 2,
          step: 0.05
        }), new NumberProperty({
          dataPath: "scaleY",
          caption: "Y",
          decimals: 2,
          step: 0.05
        })
      ]
    });
    this.rotationRow1 = new PairedInputRow({
      caption: "Rotation",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "rotation",
        sliderMin: -360,
        sliderMax: 360,
        decimals: 0,
        caption: "Z"
      })
    });
    this.rotationRow2 = new StereoInputRow({
      caption: " ",
      properties: [
        new NumberProperty({
          dataPath: "rotationX",
          caption: "X"
        }), new NumberProperty({
          dataPath: "rotationY",
          caption: "Y"
        })
      ]
    });
    this.originRow = new StereoInputRow({
      caption: "Origin",
      properties: [
        new NumberProperty({
          dataPath: "originX",
          caption: "X",
          decimals: 2,
          step: 0.1
        }), new NumberProperty({
          dataPath: "originY",
          caption: "Y",
          decimals: 2,
          step: 0.1
        })
      ]
    });
    this.skewRow = new StereoInputRow({
      caption: "Skew",
      properties: [
        new NumberProperty({
          dataPath: "skewX",
          caption: "X"
        }), new NumberProperty({
          dataPath: "skewY",
          caption: "Y"
        })
      ]
    });
    this.add(this.scaleRow1);
    this.add(this.scaleRow2);
    this.add(this.rotationRow1);
    this.add(this.rotationRow2);
    this.add(this.originRow);
    this.add(this.skewRow);
  }

  return TransformPanel;

})(Panel);


},{}],8:[function(require,module,exports){
var Constants, PropertiesPanelStack, Scroller, bridge, properties, scroller;

bridge = (require("./../shared/Bridge")).bridge;

Constants = require("./../shared/Constants").Constants;

Scroller = require("./../shared/Scroller").Scroller;

PropertiesPanelStack = require("./PropertiesPanelStack").PropertiesPanelStack;

require("../shared/BrowserBehavior");

scroller = new Scroller({
  backgroundColor: Constants.colors.background
});

properties = new PropertiesPanelStack({
  superLayer: scroller,
  backgroundColor: Constants.colors.background
});

bridge.responders.setData = properties.setData;

bridge.responders.getToggleStates = properties.getToggleStates;


},{"../shared/BrowserBehavior":11,"./../shared/Bridge":10,"./../shared/Constants":12,"./../shared/Scroller":13,"./PropertiesPanelStack":6}],9:[function(require,module,exports){
var Constants, SwitchPanel, bridge,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

bridge = require("./Bridge").bridge;

Constants = require("./Constants").Constants;

SwitchPanel = require('../shared/SwitchPanel').SwitchPanel;

exports.AutoCodePanelStack = (function(superClass) {
  extend(AutoCodePanelStack, superClass);

  function AutoCodePanelStack(options) {
    if (options == null) {
      options = {};
    }
    this.handleUndoValue = bind(this.handleUndoValue, this);
    this.handleLockProperties = bind(this.handleLockProperties, this);
    this.handleExternalValueUpdate = bind(this.handleExternalValueUpdate, this);
    this.handlePropertyRequest = bind(this.handlePropertyRequest, this);
    this.handlePropertyValueChange = bind(this.handlePropertyValueChange, this);
    this.handleLayerEdited = bind(this.handleLayerEdited, this);
    this.handleTabChange = bind(this.handleTabChange, this);
    this.setData = bind(this.setData, this);
    AutoCodePanelStack.__super__.constructor.call(this, _.defaults(options, {}));
    bridge.on("show", (function(_this) {
      return function() {
        return _this.visible = true;
      };
    })(this));
    bridge.on("hide", (function(_this) {
      return function() {
        _this.visible = false;
        return Framer.GestureInputRecognizer.reset();
      };
    })(this));
    bridge.on(Constants.messages.framerview.layerEdited, this.handleLayerEdited);
    bridge.on("externalValueUpdate", this.handleExternalValueUpdate);
    bridge.on("undoValue", this.handleUndoValue);
    bridge.on("framerView:lockProperties", this.handleLockProperties);
    this.directManipulationProperties = {};
    this.omitDefaults = true;
    this.visible = false;
    this.switchPanel = new SwitchPanel({
      currentTabName: this.currentTabName
    });
    this.switchPanel.tabs.on("change:value", this.handleTabChange);
    this.add(this.switchPanel);
  }

  AutoCodePanelStack.prototype.destroy = function() {
    return this.reset();
  };

  AutoCodePanelStack.prototype.configure = function(data) {};

  AutoCodePanelStack.prototype.setData = function(data) {
    var i, key, len, member, ref, ref1, ref2, settings, value;
    this.visible = true;
    this.reset();
    this.configure(data);
    this.pathPrefix = data.pathPrefix;
    this.switchPanel.visible = (ref = data.switchAvailable) != null ? ref : false;
    this.initialValues = data != null ? data.layerProperties : void 0;
    if (this.initialValues == null) {
      this.initialValues = {};
    }
    ref1 = this.directManipulationProperties;
    for (key in ref1) {
      value = ref1[key];
      if (this.initialValues[key] == null) {
        this.initialValues[key] = value["default"];
      }
      value.initial = this.initialValues[key];
      value.changed = false;
    }
    settings = {};
    ref2 = data.frozenMembers;
    for (i = 0, len = ref2.length; i < len; i++) {
      member = ref2[i];
      Utils.setValueForKeyPath(settings, member, {
        disabled: true
      });
    }
    this.setMembers = data.setMembers;
    if ((this.pathPrefix != null) && this.pathPrefix.length > 0) {
      this.setMembers = this.setMembers[this.pathPrefix];
      settings = settings[this.pathPrefix];
    }
    this.read(this.setMembers, this.initialValues, settings);
    this.addPropertyListeners();
    return window.scrollTo(0, 0);
  };

  AutoCodePanelStack.prototype.getData = function() {
    return this.write();
  };

  AutoCodePanelStack.prototype.addPropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      results.push(property.on("change:value", this.handlePropertyValueChange));
    }
    return results;
  };

  AutoCodePanelStack.prototype.removePropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      property.off("change:value", this.handlePropertyValueChange);
      results.push(property.reset());
    }
    return results;
  };

  AutoCodePanelStack.prototype.reset = function() {
    return this.removePropertyListeners();
  };

  AutoCodePanelStack.prototype.propertyByDataPath = function(dataPath) {
    var i, len, property, ref;
    ref = this.properties;
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      if (this.prefixDataPath(property.dataPath) === dataPath) {
        return property;
      }
    }
    return null;
  };

  AutoCodePanelStack.prototype.handleTabChange = function(value) {
    if (value === this.currentTabName) {
      return;
    }
    return bridge.send(Constants.messages.propertiespanel.activatePanel, {
      name: value
    });
  };

  AutoCodePanelStack.prototype.handleLayerEdited = function(data) {
    var changedProperties, currentValue, dataPath, newValue, property, ref, settings, value;
    this.inBatchMode = true;
    changedProperties = [];
    ref = this.directManipulationProperties;
    for (dataPath in ref) {
      settings = ref[dataPath];
      newValue = data.properties[dataPath];
      property = this.propertyByDataPath(dataPath);
      if (newValue == null) {
        continue;
      }
      if (!((property != null ? property.changed : void 0) || (this.setMembers[dataPath] != null))) {
        if ((settings.initial + "") === (newValue + "")) {
          continue;
        }
      }
      if (settings.round) {
        value = Math.round(newValue);
      } else {
        value = newValue;
      }
      if (value != null) {
        value = value + "";
      }
      if (this.omitDefaults) {
        if (value === settings["default"] + "") {
          value = null;
        }
      }
      if (value !== void 0 && (property != null)) {
        if (!this.omitDefaults && !property.changed && value === property["default"] + "") {
          value = null;
        }
        currentValue = property.getData();
        if ((value === null && currentValue !== null) || (value !== null && value.toString() !== currentValue)) {
          property.setValueWithData(value);
          property.changed = true;
          changedProperties.push({
            name: this.prefixDataPath(dataPath),
            value: value,
            type: property.type
          });
        }
      }
    }
    if (changedProperties.length > 0) {
      bridge.send(Constants.messages.propertiespanel.propertiesChanged, {
        properties: changedProperties
      });
    }
    return this.inBatchMode = false;
  };

  AutoCodePanelStack.prototype.prefixDataPath = function(dataPath) {
    if ((this.pathPrefix != null) && this.pathPrefix.length > 0) {
      return this.pathPrefix + "." + dataPath;
    } else {
      return dataPath;
    }
  };

  AutoCodePanelStack.prototype.handlePropertyValueChange = function(newValue, oldValue, prop) {
    var defaultValue, initialValue, ref, update, value;
    if (this.inBatchMode) {
      return;
    }
    value = prop.getData();
    initialValue = prop.valueToData(this.initialValues[prop.dataPath]);
    defaultValue = (ref = this.directManipulationProperties[prop.dataPath]) != null ? ref["default"] : void 0;
    if ((value == null) && initialValue !== defaultValue) {
      value = initialValue;
    }
    update = {
      name: this.prefixDataPath(prop.dataPath),
      value: value,
      type: prop.type
    };
    return bridge.send(Constants.messages.propertiespanel.propertyChanged, update);
  };

  AutoCodePanelStack.prototype.handlePropertyRequest = function(request) {
    switch (request != null ? request.type : void 0) {
      case "color":
        return bridge.send("colorPickerRequested", request);
      case "image":
        return bridge.send("imagePickerRequested", request);
      case "drag:start":
        document.body.classList.add("dragging");
        return bridge.send("drag:start", {});
      case "drag:end":
        document.body.classList.remove("dragging");
        return bridge.send("drag:end", {});
      case "click:lock":
        request.name = this.prefixDataPath(request.name);
        return bridge.send(Constants.messages.propertiespanel.propertyLockClicked, request);
    }
  };

  AutoCodePanelStack.prototype.handleExternalValueUpdate = function(update) {
    var property;
    property = this.propertyByDataPath(update != null ? update.name : void 0);
    if (property != null) {
      return property.setValueWithData(update.value);
    }
  };

  AutoCodePanelStack.prototype.handleLockProperties = function(data) {
    var i, len, p, properties, property;
    properties = data.properties;
    for (i = 0, len = properties.length; i < len; i++) {
      p = properties[i];
      property = this.propertyByDataPath(p);
      if (property != null) {
        property.enable(false);
      }
    }
  };

  AutoCodePanelStack.prototype.handleUndoValue = function(update) {
    var inBatchMode;
    inBatchMode = this.inBatchMode;
    this.inBatchMode = true;
    this.handleExternalValueUpdate(update);
    return this.inBatchMode = inBatchMode;
  };

  return AutoCodePanelStack;

})(window.FramerComponents.PanelStack);


},{"../shared/SwitchPanel":14,"./Bridge":10,"./Constants":12}],10:[function(require,module,exports){
var Bridge, EventEmitter,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

EventEmitter = require("eventemitter3");

Bridge = (function(superClass) {
  extend(Bridge, superClass);

  function Bridge() {
    this.respond = bind(this.respond, this);
    this.receive = bind(this.receive, this);
    Bridge.__super__.constructor.apply(this, arguments);
    if (typeof window !== "undefined" && window !== null) {
      window._receive = this.receive;
    }
    if (typeof window !== "undefined" && window !== null) {
      window._respond = this.respond;
    }
    this.count = 0;
    this.responders = {};
  }

  Bridge.prototype.receive = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.receive", command, info);
    }
    return this.emit(command, info);
  };

  Bridge.prototype.respond = function(request, info) {
    var responder;
    responder = this.responders[request];
    if (responder != null) {
      return responder(info);
    } else {

    }
  };

  Bridge.prototype.send = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.send", command, info);
    }
    return typeof window !== "undefined" && window !== null ? typeof window._bridge === "function" ? window._bridge(command, info) : void 0 : void 0;
  };

  return Bridge;

})(EventEmitter);

exports.bridge = new Bridge();


},{"eventemitter3":1}],11:[function(require,module,exports){
Framer.Extras.TouchEmulator.disable();

Framer.Extras.ErrorDisplay.disable();

document.addEventListener("contextmenu", function(event) {
  return event.preventDefault();
}, false);

document.addEventListener("dragover", function(event) {
  var ref;
  event.preventDefault();
  return (ref = event.dataTransfer) != null ? ref.dropEffect = "none" : void 0;
});

document.addEventListener("drop", function(event) {
  return event.preventDefault();
}, false);


},{}],12:[function(require,module,exports){
exports.Constants = {
  fonts: {
    "default": {
      font: "11px -apple-system, Helvetica Neue, Helvetica",
      weight: "500"
    }
  },
  colors: {
    background: "#141414",
    text: "#AAA",
    textHighlight: "#FFF",
    textInvisible: "rgba(98,98,98,.4)",
    indent: "#333",
    tableSelectionBackground: "#363636"
  },
  sizes: {
    base: 10,
    rowHeight: 28,
    indent: 12,
    indentWidth: 1,
    indentHeight: 28
  },
  messages: {
    layerpanel: {
      reset: "layerPanel:reset",
      itemRollOver: "layerPanel:itemRollover",
      itemRollOut: "layerPanel:itemRollout",
      itemClick: "layerPanel:itemClick",
      itemCmdClick: "layerPanel:itemCmdClick",
      itemContextMenu: "layerPanel:itemContextMenu"
    },
    propertiespanel: {
      propertiesChanged: "propertiesPanel:propertiesChanged",
      propertyChanged: "propertiesPanel:propertyChanged",
      propertyLockClicked: "propertiesPanel:propertyLockClicked",
      activatePanel: "propertiesPanel:activatePanel"
    },
    framerview: {
      layers: "framerView:layers",
      layerEdited: "framerView:layerEdited",
      layerHighlighted: "framerView:layerHighlighted"
    },
    studio: {
      state: "studio:state",
      layerPanelEnter: "studio:layerPanelEnter",
      layerPanelLeave: "studio:layerPanelLeave"
    }
  }
};


},{}],13:[function(require,module,exports){
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

exports.Scroller = (function(superClass) {
  extend(Scroller, superClass);

  function Scroller(options) {
    var ref;
    if (options == null) {
      options = {};
    }
    this.marginTop = (ref = options.y) != null ? ref : 0;
    Scroller.__super__.constructor.call(this, _.defaults(options, {
      name: "Scroller",
      y: this.marginTop,
      width: window.innerWidth,
      height: window.innerHeight - this.marginTop,
      backgroundColor: null,
      clip: true
    }));
    this.scroll = true;
    this.scrollHorizontal = false;
    window.addEventListener("resize", (function(_this) {
      return function() {
        var child, i, len, ref1, results;
        _this.height = window.innerHeight - _this.marginTop;
        _this.width = window.innerWidth;
        ref1 = _this.children;
        results = [];
        for (i = 0, len = ref1.length; i < len; i++) {
          child = ref1[i];
          results.push(typeof child.handleScrollerResize === "function" ? child.handleScrollerResize(_this.width, _this.height) : void 0);
        }
        return results;
      };
    })(this));
  }

  return Scroller;

})(Layer);


},{}],14:[function(require,module,exports){
var Panel, PanelRow, Tabs,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow;

Tabs = (function(superClass) {
  extend(Tabs, superClass);

  function Tabs(options) {
    var i, layer, len, ref;
    if (options == null) {
      options = {};
    }
    Tabs.__super__.constructor.call(this, _.defaults(options, {
      hasLabel: false,
      caption: "",
      height: 40
    }));
    this.left = new Layer({
      parent: this,
      backgroundColor: null,
      name: "properties"
    });
    this.propertiesIcon = new Layer({
      parent: this.left,
      width: 11,
      height: 11,
      backgroundColor: null,
      html: '<svg><defs><path d="M6.08474107,7 L2,7 L2,8 L6.08455121,8 C6.289826,8.58510886 6.84604119,9 7.5,9 C8.33420277,9 9,8.32842712 9,7.5 C9,6.66579723 8.32842712,6 7.5,6 C6.84233723,6 6.28934383,6.41740381 6.08474107,7 Z M4.91544879,3 L9,3 L9,4 L4.91525893,4 C4.71065617,4.58259619 4.15766277,5 3.5,5 C2.67157288,5 2,4.33420277 2,3.5 C2,2.67157288 2.66579723,2 3.5,2 C4.15395881,2 4.710174,2.41489114 4.91544879,3 Z M0,1.50643854 C0,0.674455507 0.671540633,0 1.50643854,0 L9.49356146,0 C10.3255445,0 11,0.671540633 11,1.50643854 L11,9.49356146 C11,10.3255445 10.3284594,11 9.49356146,11 L1.50643854,11 C0.674455507,11 0,10.3284594 0,9.49356146 L0,1.50643854 Z M3,3 L4,3 L4,4 L3,4 L3,3 Z M7,7 L8,7 L8,8 L7,8 L7,7 Z" id="propertiespath-1"></path><mask id="propertiesmask-2" maskContentUnits="userSpaceOnUse" maskUnits="objectBoundingBox" x="-1" y="-1" width="13" height="13"><rect x="-1" y="-1" width="13" height="13" fill="white"></rect><use xlink:href="#propertiespath-1" fill="black"></use></mask> </defs><g id="properties" stroke="none" fill="none"><use fill="#FFF" fill-rule="evenodd" xlink:href="#propertiespath-1"></use></g></svg>'
    });
    this.right = new Layer({
      parent: this,
      backgroundColor: null,
      name: "options"
    });
    this.optionsIcon = new Layer({
      parent: this.right,
      width: 11,
      height: 11,
      backgroundColor: null,
      html: '<svg><defs><rect id="optionspath-2" x="0" y="0" width="11" height="11" rx="1.5"></rect><mask id="optionsmask-2" maskContentUnits="userSpaceOnUse" maskUnits="objectBoundingBox" x="-1" y="-1" width="13" height="13"><rect x="-1" y="-1" width="13" height="13" fill="white"></rect><use xlink:href="#optionspath-1" fill="black"></use></mask></defs><g id="icon-curve-edit" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"><g id="Rectangle-272"><use fill="#FFF" fill-rule="evenodd" xlink:href="#optionspath-2"></use><use stroke="#141414" mask="url(#optionsmask-2)" stroke-width="2" xlink:href="#optionspath-1"></use></g><path d="M2,8.5 C2,8.5 8.5,8.5 8.5,2" id="Path-64" stroke="#141414"></path></g></svg>'
    });
    ref = [this.left, this.right];
    for (i = 0, len = ref.length; i < len; i++) {
      layer = ref[i];
      if (layer.name !== options.currentTabName) {
        layer.opacity = 0.5;
        layer.grayscale = 100;
      }
    }
    this.layout();
    this.left.onClick((function(_this) {
      return function() {
        return _this.emit("change:value", _this.left.name);
      };
    })(this));
    this.right.onClick((function(_this) {
      return function() {
        return _this.emit("change:value", _this.right.name);
      };
    })(this));
  }

  Tabs.prototype.layout = function() {
    var offset, width;
    width = this.width / 2;
    this.left.width = this.right.width = width;
    this.right.x = width;
    this.left.height = this.right.height = this.height;
    offset = 17;
    this.propertiesIcon.centerX(offset - 1);
    this.optionsIcon.centerX(-offset);
    this.propertiesIcon.centerY();
    this.optionsIcon.centerY();
    this.propertiesIcon.pixelAlign();
    return this.optionsIcon.pixelAlign();
  };

  return Tabs;

})(PanelRow);

exports.SwitchPanel = (function(superClass) {
  extend(SwitchPanel, superClass);

  function SwitchPanel(options) {
    if (options == null) {
      options = {};
    }
    this.render = bind(this.render, this);
    this.tabs = new Tabs({
      currentTabName: options.currentTabName
    });
    SwitchPanel.__super__.constructor.call(this, options);
    this.add(this.tabs);
  }

  SwitchPanel.prototype.render = function() {
    var i, len, offsetY, ref, row;
    offsetY = 0;
    ref = this.rows;
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      if (!row.visible) {
        continue;
      }
      row.width = this.width;
      row.y = offsetY;
      if (typeof row.layout === "function") {
        row.layout();
      }
      offsetY += row.calculatedHeight;
    }
    this.calculatedHeight = offsetY;
    return this.height = this.calculatedHeight;
  };

  return SwitchPanel;

})(Panel);


},{}]},{},[8])