{Property,NumberProperty,ColorProperty,StringProperty,OptionListProperty}  = FramerComponents
{Panel,PanelRow,MonoInputRow,StereoInputRow,PairedInputRow,SelectInput} = FramerComponents
{TextInput,ComboTextInput,NumberInput,SliderInput,DialInput,SegmentedInput,ImageInput} = FramerComponents

class exports.FontPanel extends Panel

    constructor: (options = {}) ->

        @caption = "Font"

        super _.defaults options, {}

        fontRow = new MonoInputRow
            caption: "Font"
            property: new OptionListProperty
                editorType: SelectInput
                dataPath: "fontFamily"
                availableOptions:
                    "Helvetica": "Helvetica"
                    "SF Text": "San Francisco"
                    "Courier": "Courier"

        sizeRow = new PairedInputRow
            caption: "Size"
            editorTypes: [NumberInput, SliderInput]
            property: new NumberProperty
                caption: "px"
                dataPath: "fontSize"
                min: 0
                sliderMin: 0
                sliderMax: 100
                step: 1
                decimals: 0

        weightRow = new PairedInputRow
            caption: "Weight"
            editorTypes: [NumberInput, SliderInput]
            property: new NumberProperty
                caption: ""
                dataPath: "fontWeight"
                min: 0
                sliderMin: 0
                sliderMax: 1000
                step: 100
                decimals: 0

        colorRow = new StereoInputRow
            caption: "Color"
            properties: [
                new ColorProperty dataPath: "color"
                new StringProperty
                    caption: "Choose"
                    dataPath: "color"
                    editorType: ImageInput
            ]


        alignRow = new MonoInputRow
            caption: "Align"
            property: new OptionListProperty
                editorType: SegmentedInput
                dataPath: "textAlign"
                availableOptions:
                    "left": "Left"
                    "center": "Center"
                    "right": "Right"

        lineHeightRow = new PairedInputRow
            caption: "Line"
            editorTypes: [NumberInput, SliderInput]
            property: new NumberProperty
                caption: "x"
                dataPath: "lineHeight"
                min: 0
                sliderMin: 0
                sliderMax: 3
                step: 0.1
                decimals: 1

        letterSpacingRow = new PairedInputRow
            caption: "Spacing"
            editorTypes: [NumberInput, SliderInput]
            property: new NumberProperty
                caption: "px"
                dataPath: "letterSpacing"
                min: 0
                sliderMin: 0
                sliderMax: 3
                step: 0.1
                decimals: 1

        @add fontRow
        @add sizeRow
        @add weightRow
        @add colorRow
        @add alignRow
        @add lineHeightRow
        @add letterSpacingRow
