# The PageComponent helps you create a series of layers to flick through.
# A page is a basically a layer, until you add it to a PageComponent. 
# Learn more here: framer.com/getstarted/guide/#page
# Here we also use loops and arrays to quickly add and style multiple pages at a time: framer.com/getstarted/programming/#loops-and-arrays

# Create PageComponent
page = new PageComponent 
	x: Align.center
	y: Align.center	
	width: 600
	borderRadius: 8
	scrollVertical: false
	
# Empty array of pages
pages = []

# Add pages
for i in [0...10]
	layer = new Layer 
		parent: page.content
		name: "Page #{i}"
		x: 200 * i
		scale: 0.8
		backgroundColor: "#05F"
		borderRadius: 8
		
	# Store pages within array
	pages.push(layer)

# Snap to page without an animation 
page.snapToPage(pages[5], false)

# Style current page
page.currentPage.backgroundColor = "#0AF"
page.currentPage.scale = 1

# Fade in the most centered page
page.onChange "currentPage", ->
	page.previousPage.animate 
		backgroundColor: "#05F"
		scale: 0.8
		options:
			time: 0.3

	page.currentPage.animate 
		backgroundColor: "#0AF"
		scale: 1
		options:
			time: 0.3